Assignments Assignments

Classes | Macros | Typedefs | Enumerations | Functions | Variables
jpeglib.h File Reference
`#include "jconfig.h"`
`#include "jmorecfg.h"`

Go to the source code of this file.

## Classes
struct | JQUANT_TBL
struct | JHUFF_TBL
struct | jpeg_component_info
struct | jpeg_scan_info
struct | jpeg_marker_struct
struct | jpeg_common_struct
struct | jpeg_compress_struct
struct | jpeg_decompress_struct
struct | jpeg_error_mgr
struct | jpeg_progress_mgr
struct | jpeg_destination_mgr
struct | jpeg_source_mgr
struct | jpeg_memory_mgr

## Macros
#define | JPEG_LIB_VERSION 62 /* Version 6b */
#define | DCTSIZE 8 /* The basic DCT block is 8x8 samples */
#define | DCTSIZE2 64 /* DCTSIZE squared; # of elements in a block */
#define | NUM_QUANT_TBLS 4 /* Quantization tables are numbered 0..3 */
#define | NUM_HUFF_TBLS 4 /* Huffman tables are numbered 0..3 */
#define | NUM_ARITH_TBLS 16 /* Arith-coding tables are numbered 0..15 */
#define | MAX_COMPS_IN_SCAN 4 /* JPEG limit on # of components in one scan */
#define | MAX_SAMP_FACTOR 4 /* JPEG limit on sampling factors */
#define | C_MAX_BLOCKS_IN_MCU 10 /* compressor's limit on blocks per MCU */
#define | D_MAX_BLOCKS_IN_MCU 10 /* decompressor's limit on blocks per MCU */
#define | JDCT_DEFAULT JDCT_ISLOW
#define | JDCT_FASTEST JDCT_IFAST
#define | jpeg_common_fields
#define | JMSG_LENGTH_MAX 200 /* recommended size of format_message buffer */
#define | JMSG_STR_PARM_MAX 80
#define | JPOOL_PERMANENT 0 /* lasts until master record is destroyed */
#define | JPOOL_IMAGE 1 /* lasts until done with image/datastream */
#define | JPOOL_NUMPOOLS 2
#define | JPP(arglist)
#define | jpeg_create_compress(cinfo)
#define | jpeg_create_decompress(cinfo)
#define | JPEG_SUSPENDED 0 /* Suspended due to lack of input data */
#define | JPEG_HEADER_OK 1 /* Found valid image datastream */
#define | JPEG_HEADER_TABLES_ONLY 2 /* Found valid table-specs-only datastream */
#define | JPEG_REACHED_SOS 1 /* Reached start of new scan */
#define | JPEG_REACHED_EOI 2 /* Reached end of image */
#define | JPEG_ROW_COMPLETED 3 /* Completed one iMCU row */
#define | JPEG_SCAN_COMPLETED 4 /* Completed last iMCU row of a scan */
#define | JPEG_RST0 0xD0 /* RST0 marker code */
#define | JPEG_EOI 0xD9 /* EOI marker code */
#define | JPEG_APP0 0xE0 /* APP0 marker code */
#define | JPEG_COM 0xFE /* COM marker code */

## Typedefs
typedef JSAMPLE FAR * | JSAMPROW
typedef JSAMPROW * | JSAMPARRAY
typedef JSAMPARRAY * | JSAMPIMAGE
typedef JCOEF | JBLOCK[DCTSIZE2]
typedef JBLOCK FAR * | JBLOCKROW
typedef JBLOCKROW * | JBLOCKARRAY
typedef JBLOCKARRAY * | JBLOCKIMAGE
typedef JCOEF FAR * | JCOEFPTR
typedef struct jpeg_marker_struct FAR * | jpeg_saved_marker_ptr
typedef struct jpeg_common_struct * | j_common_ptr
typedef struct jpeg_compress_struct * | j_compress_ptr
typedef struct jpeg_decompress_struct * | j_decompress_ptr
typedef struct jvirt_sarray_control * | jvirt_sarray_ptr
typedef struct jvirt_barray_control * | jvirt_barray_ptr

## Enumerations
enum | J_COLOR_SPACE { JCS_UNKNOWN , JCS_GRAYSCALE , JCS_RGB , JCS_YCbCr , JCS_CMYK , JCS_YCCK }
enum | J_DCT_METHOD { JDCT_ISLOW , JDCT_IFAST , JDCT_FLOAT }
enum | J_DITHER_MODE { JDITHER_NONE , JDITHER_ORDERED , JDITHER_FS }

## Functions
typedef | JMETHOD (boolean, jpeg_marker_parser_method,(j_decompress_ptr cinfo))
| EXTERN (struct jpeg_error_mgr *) jpeg_std_error JPP((struct jpeg_error_mgr *err))
| EXTERN (void) jpeg_CreateCompress JPP((j_compress_ptr cinfo
| EXTERN (int) jpeg_quality_scaling JPP((int quality))
| EXTERN (JQUANT_TBL *) jpeg_alloc_quant_table JPP((j_common_ptr cinfo))
| EXTERN (JHUFF_TBL *) jpeg_alloc_huff_table JPP((j_common_ptr cinfo))
| EXTERN (JDIMENSION) jpeg_write_scanlines JPP((j_compress_ptr cinfo
| EXTERN (jvirt_barray_ptr *) jpeg_read_coefficients JPP((j_decompress_ptr cinfo))

## Variables
int | version
int size_t | structsize
FILE * | outfile
FILE * | infile
J_COLOR_SPACE | colorspace
int | quality
int boolean | force_baseline
int | scale_factor
int | which_tbl
int const unsigned int * | basic_table
boolean | suppress
boolean | write_all_tables
JSAMPARRAY | scanlines
JSAMPARRAY JDIMENSION | num_lines
JSAMPIMAGE | data
int | marker
int const JOCTET * | dataptr
int const JOCTET unsigned int | datalen
int | val
boolean | require_image
JSAMPARRAY JDIMENSION | max_lines
int | scan_number
int | marker_code
int unsigned int | length_limit
int jpeg_marker_parser_method | routine
jvirt_barray_ptr * | coef_arrays
j_compress_ptr | dstinfo
int | desired

## Macro Definition Documentation

## ◆ C_MAX_BLOCKS_IN_MCU

#define C_MAX_BLOCKS_IN_MCU 10 /* compressor's limit on blocks per MCU */

## ◆ D_MAX_BLOCKS_IN_MCU

#define D_MAX_BLOCKS_IN_MCU 10 /* decompressor's limit on blocks per MCU */

## ◆ DCTSIZE

#define DCTSIZE 8 /* The basic DCT block is 8x8 samples */

## ◆ DCTSIZE2

#define DCTSIZE2 64 /* DCTSIZE squared; # of elements in a block */

## ◆ JDCT_DEFAULT

#define JDCT_DEFAULT JDCT_ISLOW

## ◆ JDCT_FASTEST

#define JDCT_FASTEST JDCT_IFAST

## ◆ JMSG_LENGTH_MAX

#define JMSG_LENGTH_MAX 200 /* recommended size of format_message buffer */

## ◆ JMSG_STR_PARM_MAX

#define JMSG_STR_PARM_MAX 80

## ◆ JPEG_APP0

#define JPEG_APP0 0xE0 /* APP0 marker code */

## ◆ JPEG_COM

#define JPEG_COM 0xFE /* COM marker code */

## ◆ jpeg_common_fields

#define jpeg_common_fields

Value:
struct jpeg_error_mgr * err; /* Error handler module */\
struct jpeg_memory_mgr * mem; /* Memory manager module */\
struct jpeg_progress_mgr * progress; /* Progress monitor, or NULL if none */\
void * client_data; /* Available for use by application */\
boolean is_decompressor; /* So common code can tell which is which */\
int global_state /* For checking call sequence validity */
jpeg_error_mgr
Definition jpeglib.h:643
jpeg_memory_mgr
Definition jpeglib.h:756
jpeg_progress_mgr
Definition jpeglib.h:701

## ◆ jpeg_create_compress

#define jpeg_create_compress | ( |  | cinfo | ) |

Value:
jpeg_CreateCompress((cinfo), JPEG_LIB_VERSION, \
(size_t) sizeof(struct jpeg_compress_struct))
jpeg_CreateCompress
jpeg_CreateCompress(j_compress_ptr cinfo, int version, size_t structsize)
Definition jcapimin.cpp:30
JPEG_LIB_VERSION
#define JPEG_LIB_VERSION
Definition jpeglib.h:33
jpeg_compress_struct
Definition jpeglib.h:268

## ◆ jpeg_create_decompress

#define jpeg_create_decompress | ( |  | cinfo | ) |

Value:
jpeg_CreateDecompress((cinfo), JPEG_LIB_VERSION, \
(size_t) sizeof(struct jpeg_decompress_struct))
jpeg_CreateDecompress
jpeg_CreateDecompress(j_decompress_ptr cinfo, int version, size_t structsize)
Definition jdapimin.cpp:30
jpeg_decompress_struct
Definition jpeglib.h:411

## ◆ JPEG_EOI

#define JPEG_EOI 0xD9 /* EOI marker code */

## ◆ JPEG_HEADER_OK

#define JPEG_HEADER_OK 1 /* Found valid image datastream */

## ◆ JPEG_HEADER_TABLES_ONLY

#define JPEG_HEADER_TABLES_ONLY 2 /* Found valid table-specs-only datastream */

## ◆ JPEG_LIB_VERSION

#define JPEG_LIB_VERSION 62 /* Version 6b */

## ◆ JPEG_REACHED_EOI

#define JPEG_REACHED_EOI 2 /* Reached end of image */

## ◆ JPEG_REACHED_SOS

#define JPEG_REACHED_SOS 1 /* Reached start of new scan */

## ◆ JPEG_ROW_COMPLETED

#define JPEG_ROW_COMPLETED 3 /* Completed one iMCU row */

## ◆ JPEG_RST0

#define JPEG_RST0 0xD0 /* RST0 marker code */

## ◆ JPEG_SCAN_COMPLETED

#define JPEG_SCAN_COMPLETED 4 /* Completed last iMCU row of a scan */

## ◆ JPEG_SUSPENDED

#define JPEG_SUSPENDED 0 /* Suspended due to lack of input data */

## ◆ JPOOL_IMAGE

#define JPOOL_IMAGE 1 /* lasts until done with image/datastream */

## ◆ JPOOL_NUMPOOLS

#define JPOOL_NUMPOOLS 2

## ◆ JPOOL_PERMANENT

#define JPOOL_PERMANENT 0 /* lasts until master record is destroyed */

## ◆ JPP

#define JPP | ( |  | arglist | ) |

Value:
arglist

## ◆ MAX_COMPS_IN_SCAN

#define MAX_COMPS_IN_SCAN 4 /* JPEG limit on # of components in one scan */

## ◆ MAX_SAMP_FACTOR

#define MAX_SAMP_FACTOR 4 /* JPEG limit on sampling factors */

## ◆ NUM_ARITH_TBLS

#define NUM_ARITH_TBLS 16 /* Arith-coding tables are numbered 0..15 */

## ◆ NUM_HUFF_TBLS

#define NUM_HUFF_TBLS 4 /* Huffman tables are numbered 0..3 */

## ◆ NUM_QUANT_TBLS

#define NUM_QUANT_TBLS 4 /* Quantization tables are numbered 0..3 */

## Typedef Documentation

## ◆ j_common_ptr

typedef struct jpeg_common_struct* j_common_ptr

## ◆ j_compress_ptr

typedef struct jpeg_compress_struct* j_compress_ptr

## ◆ j_decompress_ptr

typedef struct jpeg_decompress_struct* j_decompress_ptr

## ◆ JBLOCK

typedef JCOEF JBLOCK[DCTSIZE2]

## ◆ JBLOCKARRAY

typedef JBLOCKROW* JBLOCKARRAY

## ◆ JBLOCKIMAGE

typedef JBLOCKARRAY* JBLOCKIMAGE

## ◆ JBLOCKROW

typedef JBLOCK FAR* JBLOCKROW

## ◆ JCOEFPTR

typedef JCOEF FAR* JCOEFPTR

## ◆ jpeg_saved_marker_ptr

typedef struct jpeg_marker_struct FAR* jpeg_saved_marker_ptr

## ◆ JSAMPARRAY

typedef JSAMPROW* JSAMPARRAY

## ◆ JSAMPIMAGE

typedef JSAMPARRAY* JSAMPIMAGE

## ◆ JSAMPROW

typedef JSAMPLE FAR* JSAMPROW

## ◆ jvirt_barray_ptr

typedef struct jvirt_barray_control* jvirt_barray_ptr

## ◆ jvirt_sarray_ptr

typedef struct jvirt_sarray_control* jvirt_sarray_ptr

## Enumeration Type Documentation

## ◆ J_COLOR_SPACE

enum J_COLOR_SPACE

Enumerator
JCS_UNKNOWN |
JCS_GRAYSCALE |
JCS_RGB |
JCS_YCbCr |
JCS_CMYK |
JCS_YCCK |

## ◆ J_DCT_METHOD

enum J_DCT_METHOD

Enumerator
JDCT_ISLOW |
JDCT_IFAST |
JDCT_FLOAT |

## ◆ J_DITHER_MODE

enum J_DITHER_MODE

Enumerator
JDITHER_NONE |
JDITHER_ORDERED |
JDITHER_FS |

## Function Documentation

## ◆ EXTERN() [1/7]

EXTERN | ( | int |  | ) |

## ◆ EXTERN() [2/7]

EXTERN | ( | JDIMENSION |  | ) |

## ◆ EXTERN() [3/7]

EXTERN | ( | JHUFF_TBL * |  | ) |

## ◆ EXTERN() [4/7]

EXTERN | ( | JQUANT_TBL * |  | ) |

## ◆ EXTERN() [5/7]

EXTERN | ( | jvirt_barray_ptr * |  | ) |

## ◆ EXTERN() [6/7]

EXTERN | ( | struct jpeg_error_mgr * |  | ) |

## ◆ EXTERN() [7/7]

EXTERN | ( | void |  | ) |

## ◆ JMETHOD()

typedef JMETHOD | ( | boolean | ,
|  | jpeg_marker_parser_method | ,
|  | (j_decompress_ptr cinfo) | )

## Variable Documentation

## ◆ basic_table

int const unsigned int* basic_table

## ◆ coef_arrays

jvirt_barray_ptr* coef_arrays

## ◆ colorspace

J_COLOR_SPACE colorspace

## ◆ data

JSAMPIMAGE data

## ◆ datalen

int unsigned int datalen

## ◆ dataptr

int const JOCTET* dataptr

## ◆ desired

int desired

## ◆ dstinfo

j_compress_ptr dstinfo

## ◆ force_baseline

int const unsigned int int boolean force_baseline

## ◆ infile

FILE* infile

## ◆ length_limit

int unsigned int length_limit

## ◆ marker

int marker

## ◆ marker_code

int marker_code

## ◆ max_lines

JSAMPIMAGE JDIMENSION max_lines

## ◆ num_lines

JSAMPIMAGE JDIMENSION num_lines

## ◆ outfile

FILE* outfile

## ◆ quality

int quality

## ◆ require_image

boolean require_image

## ◆ routine

int jpeg_marker_parser_method routine

## ◆ scale_factor

int const unsigned int int scale_factor

## ◆ scan_number

int scan_number

## ◆ scanlines

JSAMPARRAY scanlines

## ◆ structsize

int size_t structsize

## ◆ suppress

boolean suppress

## ◆ val

int val

## ◆ version

int version

## ◆ which_tbl

int which_tbl

## ◆ write_all_tables

boolean write_all_tables